(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = global || self, factory(global.GlobalLight = {}, global.React));
}(this, (function (exports, React) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it;

    if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;

        var F = function () {};

        return {
          s: F,
          n: function () {
            if (i >= o.length) return {
              done: true
            };
            return {
              done: false,
              value: o[i++]
            };
          },
          e: function (e) {
            throw e;
          },
          f: F
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true,
        didErr = false,
        err;
    return {
      s: function () {
        it = o[Symbol.iterator]();
      },
      n: function () {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function (e) {
        didErr = true;
        err = e;
      },
      f: function () {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }

  var PresetContext = React.createContext();
  var RouterContext = React.createContext();
  var GlobalContext = React.createContext();
  var CustContext = React.createContext();
  var PresetContextProvider = function PresetContextProvider(_ref) {
    var reducer = _ref.reducer,
        initState = _ref.initState,
        children = _ref.children;
    return /*#__PURE__*/React__default.createElement(PresetContext.Provider, {
      value: React.useReducer(reducer, initState)
    }, children);
  };
  var useStateValue = function useStateValue() {
    return React.useContext(PresetContext);
  };
  var RoutingContextProvider = function RoutingContextProvider(_ref2) {
    var reducer = _ref2.reducer,
        initialState = _ref2.initialState,
        children = _ref2.children;
    return /*#__PURE__*/React__default.createElement(RouterContext.Provider, {
      value: React.useReducer(reducer, initialState)
    }, children);
  };
  /**
   * Global State container that has been updated, but kept in-order for 
   * backwards compatibility. Really the custContext component will 
   * function the same.
   * 
   * @param {Function} props.reducer - Function to access and mutate data stored within initial state
   * @param {Object} props.initialState - Initial state for context system
   * @param {Object} props.children - Default value passed with props from react 
   */

  var GlobalContextProvider = function GlobalContextProvider(_ref3) {
    var reducer = _ref3.reducer,
        initialState = _ref3.initialState,
        children = _ref3.children;
    return /*#__PURE__*/React__default.createElement(GlobalContext.Provider, {
      value: React.useReducer(reducer, initialState)
    }, children);
  };
  /**
   * Experimental!
   * 
   * This will append a new context given the name passed to the store and initialize
   * a provider off the newly created context.
   * 
   * @param {String} props.name - Name of the new context
   * @param {Function} props.reducer - The reducer function that will invoked be used upon calling this context
   * @param {Object} props.initialState - Will hold the initial state of the context
   * @param {Object} props.children - Will be passed by default when children present inside of JSX elements
   */

  var CustContextProvider = function CustContextProvider(_ref4) {
    var reducer = _ref4.reducer,
        initialState = _ref4.initialState,
        children = _ref4.children;
    return /*#__PURE__*/React__default.createElement(CustContext.Provider, {
      value: React.useReducer(reducer, initialState)
    }, children);
  };
  /**
   * Custom hook of sorts that is to be used to access context
   *  
   * @param {String} contextName - Name to get context being stored within context store
   */

  var useCustomContext = function useCustomContext(contextName) {
    var routing = React.useContext(RouterContext);
    var ctxt = React.useContext(GlobalContext);
    var preset = React.useContext(PresetContext);
    var cust = React.useContext(CustContext);

    switch (contextName) {
      case "routing":
      case "router":
      case "Router":
        return routing;

      case "global":
      case "Global":
        return ctxt;

      case "preset":
      case "Preset":
        return preset;

      default:
        return cust;
    }
  };
  /*
  export const removeContext = (contextName = "GlobalContext") => {
      delete contextStore[contextName];
  }*/

  /**
   * This will attempt to generate switch-case like behavior automatically based on the initial state passed to the program. Think of 
   * setState from React except mutating global scope rather than local scope only. This may be changed to run the ruducer with Promies
   * in the future but right now a synchronous function that O(1) is utilized leaving no need until customization is brought into the 
   * picture to do uncertain nature of other peoples code.
   * 
   * Values cannot be mapped if they are not in the initial state
   * 
   * @param {Object} Config.stateI This contains the initial state of the funciton and will attempt to generate switch case like behavior
   * @param {Object} Config.children Property used by react to pass child elements and props down chain 
   */

  var GlobalStore = function GlobalStore(_ref) {
    var stateI = _ref.stateI,
        children = _ref.children;
    var valMap = {};
    var initialState = {};
    /* 
        Symbol.iterator is a built in Symbol that is used with generators and for...of 
        loops as these for a function on Symbol.iterator. Hence why a function is
        the Right Hand Side (RHS) is the logical equivalence check of value and type
    */

    if (typeof stateI[Symbol.iterator] === "function") {
      // Generating functions for values passed in the initial state
      var _iterator = _createForOfIteratorHelper(stateI),
          _step;

      try {
        var _loop = function _loop() {
          var ele = _step.value;

          // Placing this bound anaonymous functions for each entry in the initial state, stateIZ
          valMap["set".concat(ele)] = function (state, action) {
            // Since an object is being updated all the values must be placed in then the updated value
            // setState from class-based components does this for the user, hooks do not
            return _objectSpread2(_objectSpread2({}, state), {}, {
              ele: action["new".concat(ele)]
              /* The symbol declaritive style for objects is used here as it "hides" the property 
                 on print and allows for var key explicitly */

            });
          };
        };

        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          _loop();
        } /// Initializing state

      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      initialState = _objectSpread2({}, stateI);
    } else {
      var _loop2 = function _loop2(ele) {
        valMap["set".concat(ele)] = function (state, action) {
          return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, ele, action[ele]));
        };
      };

      // Generating function as above, but using the key each passed instead here as for...in will return object keys
      for (var ele in stateI) {
        _loop2(ele);
      } // Maybe redundant now, but would have to check. Spread operator may work better. Initializes state


      for (var _ele in stateI) {
        initialState[_ele] = stateI[_ele];
      }
    }
    /*
        Instead of switch-case as below, will check if the property requested exists.
        If not the current state is returned with no warning or error. This should
        likely be changed.
          A reducer function takes some current state and an action object
            In this implementation once the action object is recieved the following occurs:
                1. Action.type is checked if it exist as a property of the generated
                   functions from above
                     If true, then pass the parameters to invoke the logic generated above
                   If false, then return the current state
    */


    var reducer = function reducer(state, action) {
      if (process.env.DEBUG) {
        console.groupCollapsed("Routing: ");
        console.log(state);
        console.log(action);
        console.log(valMap);
        console.groupEnd();
      }

      if (valMap.hasOwnProperty(action.type)) {
        return valMap[action.type](state, action);
      } else {
        return state;
      }
    };

    return /*#__PURE__*/React__default.createElement(GlobalContextProvider, {
      initialState: initialState,
      reducer: reducer
    }, children);
  };
  /**
   * RouterStore will contain the state portion of page routing. This is to
   * have tracibility and set paths linked to componenets.
   * 
   * @param {Object} props.stateI - Contains the routes of the application
   * @param {Object} props.children - React will pass this down by default 
   */

  var RouterStore = function RouterStore(_ref2) {
    var stateI = _ref2.stateI,
        children = _ref2.children;

    var initialState = _objectSpread2({}, stateI);

    var reducer = function reducer(state, action) {
      if (process.env.DEBUG) {
        console.groupCollapsed("Reducer Action: ");
        console.log(action); // Debug the action being called upon state container

        console.groupEnd();
      }

      switch (action.type) {
        case 'changeRoute':
          return _objectSpread2(_objectSpread2({}, state), {}, {
            currPath: action.newPath
          });

        case 'setRoutes':
          return _objectSpread2(_objectSpread2({}, state), {}, {
            routes: action.newRoutes
          });

        case 'setActiveComp':
          return _objectSpread2(_objectSpread2({}, state), {}, {
            ActiveComp: action.newComp
          });

        case 'setId':
          return _objectSpread2(_objectSpread2({}, state), {}, {
            id: action.newId
          });

        case "set".concat(action.key):
          return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, action.key, action.value));

        default:
          return state;
      }
    };

    return /*#__PURE__*/React__default.createElement(RoutingContextProvider, {
      initialState: initialState,
      reducer: reducer
    }, children);
  };
  /**
   * This is the Generic store that has four generic options in the reducer
   * function used for state mutation. These functions are:
   *      - setValue
   *          x Will create or update values that are specified
   *          x However, if they value has been deleted then an error will 
   *            be thrown
   *      - deleteValue
   *          x A graveyard flag is added to the value, and the previously
   *            stored value is archieved
   *      - recoverValue
   *          x Will remove the graveyard flag and reset the value to the
   *            one that was archieved
   * 
   * Please note that action objects must be formatted as:
   *      {type: [action], [key]: [value]}
   * The reasoning is that the key is calculated with the keys of the Object
   * thus even if the function doesn't take a value any must be passed as it 
   * will be "thrown out" by the GC. This maybe changed eventually.
   * 
   * @param {String} name - Name of the context container
   * @param {Object} stateI - Object containing the initial values of this generic state object 
   */

  var Store = function Store(_ref3) {
    var stateI = _ref3.stateI,
        children = _ref3.children;

    var initState = _objectSpread2({}, stateI);

    var reducer = function reducer(state, action) {
      var key = Object.keys(action)[1];

      switch (action.type) {
        case "setValue":
          if (state.hasOwnProperty(key)) {
            if (state[key] !== undefined && state[key].hasOwnProperty("graveyard")) {
              throw SyntaxError("Value has been deleted please use recoverValue");
            }
          }

          return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, key, action[key]));

        case "deleteValue":
          return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, key, _defineProperty({
            graveyard: true
          }, key, state[key])));

        case "recoverValue":
          return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, key, state[key][key]));

        default:
          console.log("Please use setValue or expand reducer with custom function instead of ".concat(action.type));
          console.log(state);
          break;
      }
    };

    return /*#__PURE__*/React__default.createElement(CustContextProvider, {
      reducer: reducer,
      initialState: initState
    }, children);
  };

  var ErrorBoundary = /*#__PURE__*/function (_React$Component) {
    _inherits(ErrorBoundary, _React$Component);

    var _super = _createSuper(ErrorBoundary);

    function ErrorBoundary(props) {
      var _this;

      _classCallCheck(this, ErrorBoundary);

      _this = _super.call(this, props);
      _this.state = {
        errorInfo: null,
        error: null
      };
      return _this;
    }

    _createClass(ErrorBoundary, [{
      key: "componentDidCatch",
      value: function componentDidCatch(error, errorInfo) {
        this.setState({
          error: error,
          errorInfo: errorInfo
        });
      }
    }, {
      key: "render",
      value: function render() {
        if (this.props.isLoading) {
          return /*#__PURE__*/React__default.createElement("div", {
            className: "loading-container"
          }, /*#__PURE__*/React__default.createElement("div", {
            className: "loading"
          }));
        } else if (this.state.hasError) {
          return /*#__PURE__*/React__default.createElement("summary", null, /*#__PURE__*/React__default.createElement("h3", null, "Something went wrong"), /*#__PURE__*/React__default.createElement("details", null, this.state.error && this.state.error.toString(), /*#__PURE__*/React__default.createElement("br", null), this.state.errorInfo.componentStack));
        } else {
          return this.props.children;
        }
      }
    }]);

    return ErrorBoundary;
  }(React__default.Component);

  /**
   * This link componenet is set-up to integrate compatibility with the 
   * history API with a native `a` tag.
   * 
   * @param {String} props.url               - Url to navigate to
   * @param {String} props.name              - Name of link
   * @param {String} props.className         - CSS class to style link with
   * @param {React.Component} [props.Button] - Button element
   */

  var Link = function Link(_ref) {
    var url = _ref.url,
        name = _ref.name,
        className = _ref.className,
        Button = _ref.Button,
        children = _ref.children;

    var _useCustomContext = useCustomContext("routing"),
        _useCustomContext2 = _slicedToArray(_useCustomContext, 2),
        setCurrPath = _useCustomContext2[1]; // Custom Hook for global context


    var handleClick = function handleClick(ev) {
      ev.preventDefault(); // console.log(currPath) // To debug current path

      window.history.pushState({}, undefined, url); // Purely stores current page with History Browswer API

      setCurrPath({
        type: 'changeRoute',
        newPath: url
      });
    };

    if (Button) {
      return /*#__PURE__*/React__default.createElement(Button, {
        className: className,
        onClick: handleClick
      }, name);
    } else {
      return /*#__PURE__*/React__default.createElement("a", {
        className: className,
        onClick: handleClick
      }, children);
    } // return (
    //     <a href={'_blank'}
    //        rel="noopener norefferer"
    //        onClick={handleClick}
    //        className={linkClass}>{name}</a>
    // );

  };
  /**
   * This component will store the routes for the SPA, act as the mutator of
   * state for the routing, and push any changes of the url to the History
   * Web API to allow for expected behavior with the browser while reacting
   * to these changes.
   * 
   * Subject to change
   *   Route objects must follow as such:
   *     {
   *          id: [id], 
   *          path: [path], 
   *          name:[name], 
   *          component: [React.Component],
   *          no: [bool] // Optional and will only have effect if using navbar as it will skip rendering this route
   *      }    
   * 
   * @param {Array} RoutesArr - Stores the routes that the application can access
   * @param {Object} children - React default property that has children elements within JSX
   */

  var Router = function Router(_ref2) {
    var Header = _ref2.Header,
        Footer = _ref2.Footer,
        routesArr = _ref2.routesArr,
        className = _ref2.className,
        children = _ref2.children;

    var _useCustomContext3 = useCustomContext("routing"),
        _useCustomContext4 = _slicedToArray(_useCustomContext3, 2),
        ActiveComp = _useCustomContext4[0].ActiveComp,
        setComp = _useCustomContext4[1];

    var _useCustomContext5 = useCustomContext("routing"),
        _useCustomContext6 = _slicedToArray(_useCustomContext5, 2),
        currPath = _useCustomContext6[0].currPath,
        setPath = _useCustomContext6[1];

    var _useCustomContext7 = useCustomContext("routing"),
        _useCustomContext8 = _slicedToArray(_useCustomContext7, 2),
        setId = _useCustomContext8[1];

    var _useCustomContext9 = useCustomContext("routing"),
        _useCustomContext10 = _slicedToArray(_useCustomContext9, 2),
        routes = _useCustomContext10[0].routes,
        setRoutes = _useCustomContext10[1];

    React.useEffect(function () {
      setRoutes({
        type: 'setRoutes',
        newRoutes: routesArr
      });

      if (currPath !== undefined) {
        var url = window.location.pathname.split('/').slice(1);

        var _iterator = _createForOfIteratorHelper(routes),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var i = _step.value;
            var pathIdx = i.path.indexOf(currPath);

            if (pathIdx !== -1) {
              setComp({
                type: 'setActiveComp',
                newComp: i.component
              });
              break;
            }

            pathIdx = 0;
            var match = i.path[pathIdx].match(/:\w+/g);
            var splitPath = i.path[pathIdx].split('/').slice(1);
            var idx = splitPath.indexOf(match !== null ? match[0] : -1);

            if (match !== undefined && idx !== -1 && url[idx - 1].indexOf(splitPath[idx - 1]) !== -1) {
              setId({
                type: 'setId',
                newId: url[idx]
              });
              setComp({
                type: 'setActiveComp',
                newComp: i.component
              });
              break;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      } else {
        setPath({
          type: 'changeRoute',
          newPath: window.location.pathname
        });
      }

      window.onpopstate = function (e) {
        e.preventDefault();
        setPath({
          type: 'changeRoute',
          newPath: window.location.pathname
        });
      };
    }, [currPath, routes, setComp, setId, setPath, routesArr, setRoutes]);

    if (ActiveComp === undefined) {
      return /*#__PURE__*/React__default.createElement("div", {
        className: className
      }, Header || null, /*#__PURE__*/React__default.createElement("div", {
        className: "container"
      }, children, /*#__PURE__*/React__default.createElement("p", null, "Link not Found!")), Footer || null);
    } else {
      return /*#__PURE__*/React__default.createElement("div", {
        className: className
      }, Header || null, /*#__PURE__*/React__default.createElement(ErrorBoundary, null, ActiveComp), Footer || null);
    }
  };
  /*

  These will be implemented at a later date as they will be used to make
  so routes can be passed as jsx rather than array in props.

  export const Route = ({ pathT, componentT, nameT }) => {
      return (
          <div path={pathT} comp={componentT} name={nameT}></div>
      );
  };

  function* generateId() {
      let i = 0;
      while(true) {
          yield i++;
      }
  }
  */

  var Routing = function Routing(_ref) {
    var initialState = _ref.initialState,
        Header = _ref.Header,
        Footer = _ref.Footer,
        routes = _ref.routes,
        className = _ref.className,
        children = _ref.children;
    var component = routes.findIndex(function (x) {
      var curr = window.location.pathname;

      if (x.path.indexOf(curr) !== -1) {
        return x;
      }

      return '';
    });

    var initState = _objectSpread2(_objectSpread2({}, initialState), {}, {
      ActiveComp: routes[component]["component"],
      currPath: window.location.pathname,
      id: '',
      routes: routes
    });

    return /*#__PURE__*/React__default.createElement(RouterStore, {
      initialState: initState
    }, /*#__PURE__*/React__default.createElement(Router, {
      routesArr: routes,
      className: className
    }, children));
  };

  /*
      Tests values updating and calling re-render cycles properly
  */

  var EffectTest = function EffectTest(_ref) {
    var name = _ref.name,
        children = _ref.children;

    var _useCustomContext = useCustomContext(name),
        _useCustomContext2 = _slicedToArray(_useCustomContext, 2),
        state = _useCustomContext2[0],
        dispatch = _useCustomContext2[1];

    React.useEffect(function () {
      console.log("New Value: ".concat(state.value));
      console.log(state.rand);
    }, [state.value, state.rand]);
    return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("p", null, "New Value ", state.value), /*#__PURE__*/React__default.createElement("p", null, "Rand value ", state.rand), children);
  };
  /*
      Tests setting inputs with the Global Store
  */


  var ValueEle = function ValueEle(_ref2) {
    var name = _ref2.name,
        children = _ref2.children;

    var _useState = React.useState(),
        _useState2 = _slicedToArray(_useState, 2),
        inputVal = _useState2[0],
        setInputVal = _useState2[1];

    var _useCustomContext3 = useCustomContext(name),
        _useCustomContext4 = _slicedToArray(_useCustomContext3, 2),
        state = _useCustomContext4[0],
        dispatch = _useCustomContext4[1];

    React.useEffect(function () {
      console.log("How was random trigger?!");
    }, [state.rand]); // Global store setting values

    var handleClick = function handleClick(e) {
      e.preventDefault();
      dispatch({
        type: "setValue",
        value: inputVal
      });
    }; // Normal way of submitting change to local state


    var handleInput = function handleInput(e) {
      console.log(e);
      setInputVal(e.target.value);
    };

    return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("p", null, "Last passed value: ", state.value), /*#__PURE__*/React__default.createElement("label", {
      htmlFor: "val"
    }, "New Value: ", /*#__PURE__*/React__default.createElement("input", {
      id: "val",
      onChange: handleInput
    })), /*#__PURE__*/React__default.createElement("button", {
      onClick: handleClick
    }, "Submit"), children);
  }; // Reducer function example


  var reducer = function reducer(state, action) {
    var key = Object.keys(action)[1];

    switch (action.type) {
      case "setValue":
        return _objectSpread2(_objectSpread2({}, state), {}, _defineProperty({}, key, action[key]));
    }
  }; // Base element of for testing adding objects


  var ValTest = function ValTest(_ref3) {
    var initialState = _ref3.initialState;
    return /*#__PURE__*/React__default.createElement(CustContextProvider, {
      name: "Val",
      reducer: reducer,
      initialState: initialState
    }, /*#__PURE__*/React__default.createElement(EffectTest, {
      name: "Val"
    }), /*#__PURE__*/React__default.createElement(ValueEle, {
      name: "Val"
    }));
  }; // Old system, this is much more direct of the context being used and not as flexible as the new system

  var OldEffect = function OldEffect() {
    var _useStateValue = useStateValue(),
        _useStateValue2 = _slicedToArray(_useStateValue, 2),
        value = _useStateValue2[0].value,
        setVal = _useStateValue2[1]; // Notice the Context is automatically handed by this custom hook
    //const [{ rand },] = useStateValue();


    React.useEffect(function () {
      console.log("New value: ".concat(value));
    }, [value]); // Display

    return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("p", null, "New Value: ", value));
  }; // Old value, this is for setting the vlaue in global state with the old system


  var OldValue = function OldValue() {
    var _useState3 = React.useState(),
        _useState4 = _slicedToArray(_useState3, 2),
        input = _useState4[0],
        setInput = _useState4[1];

    var _useStateValue3 = useStateValue(),
        _useStateValue4 = _slicedToArray(_useStateValue3, 2),
        setVal = _useStateValue4[1];

    var _useStateValue5 = useStateValue(),
        _useStateValue6 = _slicedToArray(_useStateValue5, 1),
        rand = _useStateValue6[0].rand;

    React.useEffect(function () {
      console.log("How was rand changed?!");
    }, [rand]);

    var handleInput = function handleInput(e) {
      console.log(e);
      setInput(e.target.value);
    }; // Setting the value in the old is similar to the new except for the big difference being type verb


    var handleSubmit = function handleSubmit(e) {
      console.log(e.target);
      setVal({
        type: "setValue",
        value: input
      });
    };

    return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("label", null, "Input Value: ", /*#__PURE__*/React__default.createElement("input", {
      onChange: handleInput
    })), /*#__PURE__*/React__default.createElement("button", {
      onClick: handleSubmit
    }, "Submit"));
  }; // Base componenet for the old test


  var OldTest = function OldTest(_ref4) {
    var initialState = _ref4.initialState;
    return /*#__PURE__*/React__default.createElement(PresetContextProvider, {
      reducer: reducer,
      initState: initialState
    }, /*#__PURE__*/React__default.createElement(OldEffect, null), /*#__PURE__*/React__default.createElement(OldValue, null));
  };

  exports.CustContextProvider = CustContextProvider;
  exports.GlobalStore = GlobalStore;
  exports.Link = Link;
  exports.OldTest = OldTest;
  exports.Router = Router;
  exports.RouterStore = RouterStore;
  exports.Routing = Routing;
  exports.RoutingContextProvider = RoutingContextProvider;
  exports.Store = Store;
  exports.ValTest = ValTest;
  exports.useCustomContext = useCustomContext;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
